Package org.jcsp.plugNplay.ints

# Class NandInt

java.lang.Object
org.jcsp.plugNplay.ints.NandInt

All Implemented Interfaces:
  `CSProcess`

public final class NandInt extends Object implements CSProcess
Bitwise nands two integer streams to one stream.

## Process Diagram

        in0  _________
       -->--|         | out
        in1 | NandInt |-->--
       -->--|_________|

## Description

`NandInt` is a process whose output strean is the bitwise nand of the integers on its input streams.

## Channel Protocols

Input Channels
All channels in this package carry integers.
in0, in1 | int
Output Channels
out | int | All channels in this package carry integers.

## Example

The following example shows how the use of this process in a small program. The program also uses some of the other building block processes. It generates a sequence of numbers, rounds each odd number down to the nearest even number, negates them and prints them to the screen.

     import org.jcsp.lang.*;
     import org.jcsp.plugNplay.ints.*;

     public class NandIntExample {

       public static void main (String[] argv) {

         final One2OneChannelInt a = Channel.one2oneInt ();
         final One2OneChannelInt b = Channel.one2oneInt ();
         final One2OneChannelInt c = Channel.one2oneInt ();
         final One2OneChannelInt d = Channel.one2oneInt ();

         new Parallel (
           new CSProcess[] {
             new NumbersInt (a.out ()),
             new GenerateInt (b.out (), Integer.MAX_VALUE - 1),
             new NandInt (a.in (), b.in (), c.out ()),
             new SuccessorInt (c.in (), d.out ()),
             new PrinterInt (d.in (), "--> ", "\n")
           }
         ).run ();

       }

     }

Author:
  P.H. Welch and P.D. Austin

## Constructor Summary

Constructors
Constructor
Description
`NandInt(ChannelInputInt in0, ChannelInputInt in1, ChannelOutputInt out)`
Construct a new NandInt process with the input Channels in0 and in1 and the output Channel out.

## Method Summary

Modifier and Type
Method
Description
`void`
`run()`
The main body of this process.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### NandInt

public NandInt(ChannelInputInt in0, ChannelInputInt in1, ChannelOutputInt out)
Construct a new NandInt process with the input Channels in0 and in1 and the output Channel out. The ordering of the Channels in0 and in1 make no difference to the functionality of this process.

Parameters:
  `in0` - the first input Channel
  `in1` - the second input Channel
  `out` - the output Channel

## Method Details

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`